<?php
/*
Plugin Name: Flattr Shortcode Widget
Version: 0.3.0
Plugin URI: http://wordpress.org/extend/plugins/flattr-widget/
Description: Provides easy shortcode access to inserting custom Flattr widgets as well as options for adding a 
Author: Fabrizio Lungo
Author URI: http://fabrizio.me.uk/

Copyright 2010 Fabrizio Lungo (email: flattr-widget@fabrizio.me.uk)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function determine_flattr_uid($uid,$author_uid,$blog_uid) {
	$flattr_author_uid	=	get_option('flattr_author_uid');
	if (!empty($uid))
		$flattr_uid		= 	$uid;
	elseif (!empty($author_uid) && $flattr_author_uid == 'true')
		$flattr_uid		=	$author_uid;
	elseif (!empty($blog_uid))
		$flattr_uid		= 	$blog_uid;
		
	return $flattr_uid;
}

function determine_flattr_cat($input) {
	$input = strtolower($input);
	switch($input) {
		case 'audio':
			return "audio";
		case 'images':
		case 'image':
			return "images";
		case 'video':
		case 'videos':
			return "video";
		case 'software':
			return "software";
		case 'rest':
		case 'other':
			return "rest";
		case 'text':
		default:
			return "text";
	}
}

function determine_flattr_lng($input) {
	if (!isset($input))
		return "en_GB";
	else
		return $input;
}

function determine_flattr_tf($input,$default) {
	if ($input != '1' && $input != '0') {
		$input = $default;
		return $input;
	}
	else
		return $input;
}

function flattr_trim(&$input) 
{ 
    $input = preg_replace('/\s\s+/', ' ', trim($input)); 
}

function flattr_widget($atts, $content) {
	$blog_uid			=	get_option('flattr_uid');
	if (!empty($content) && empty($atts['uid']))
		$atts['uid']	=	$content;
	$author_id			=	get_the_author_meta('id');
	$author_uid			=	get_user_meta($author_id, 'flattr_uid', true);
	if ($atts['uid'] != '' || $blog_uid != '' || (!empty($author_uid) && $flattr_author_uid == 'true')) {
		if ($atts['btn'] != '')
			$flattr['btn']		=	$atts['btn'];
		$flattr['uid']			= 	determine_flattr_uid($atts['uid'],$author_uid,$blog_uid);
		if ($atts['tle'] != '')
			$flattr['tle']		=	$atts['tle'];
		else
			$flattr['tle']		=	get_the_title();
		if ($atts['dsc'] != '')
			$flattr['dsc']		=	$atts['dsc'];
		elseif (get_the_excerpt() != '')
			$flattr['dsc']		=	get_the_excerpt();
		else
			$flattr['dsc']		=	'No Description...';
		$flattr['cat']			=	determine_flattr_cat($atts['cat']);
		$flattr['lng']			=	determine_flattr_lng($atts['lng']);
		if ($atts['tag'] != '')
			$flattr['tag']		=	$atts['tag'];
		if ($atts['url'] != '')
			$flattr['url']		=	$atts['url'];
		else
			$flattr['url']		=	get_permalink();
		$flattr['hide']			=	determine_flattr_tf($atts['hide'],'0');
		if ($atts['anc'] != '')
			$flattr['anc']		=	$atts['anc'];
		$flattr['setanc']		=	determine_flattr_tf($atts['setanc'],'1');
		if ($atts['qty'] != '')
			$flattr['qty']		=	$atts['qty'];
		else
			$flattr['qty']		=	"1";
		if ($atts['rssurl'] != '')
			$flattr['rssurl']	=	$atts['rssurl'];
		else
			$flattr['rssurl']	=	"http://flattr.com";
			
		array_walk($flattr, 'flattr_trim');
		
		if (!is_feed()) {
			$output =		 "<!-- WordPress Flattr Shortcode Widget -->\n";
			if ($flattr['setanc'] == '1' && $flattr['anc'] != '') {
				$output .= 	 "<a name=\"" . $flattr['anc'] . "\"></a>\n";
			}
			$output .= 		 "<script type=\"text/javascript\">\n";
			if ($flattr['btn'] != '')
				$output .=	 "var flattr_btn = '" . $flattr['btn'] . "';\n";
			$output .=		 "var flattr_uid = '" . $flattr['uid'] . "';\n"
							."var flattr_tle = '" . $flattr['tle'] . "';\n"
							."var flattr_dsc = '" . $flattr['dsc'] . "';\n"
							."var flattr_cat = '" . $flattr['cat'] . "';\n"
							."var flattr_lng = '" . $flattr['lng'] . "';\n";
			if ($flattr['tag'] != '')
				$output .=	 "var flattr_tag = '" . $flattr['tag'] . "';\n";
			if ($flattr['url'] != '') {
				$output .=	 "var flattr_url = '" . $flattr['url'];
				if ($flattr['anc'] != '')
					$output .=	 "#" . $flattr['anc'];
				$output .=	 "';\n";
			}
			$output 	.=	 "var flattr_hide = '" . $flattr['hide'] . "';\n"
							."</script>\n"
							."<script src=\"http://api.flattr.com/button/load.js\" type=\"text/javascript\"></script>\n";
			$i = $flattr['qty'];
			while ($i > 1) {
				$output		.=	 "<a name=\"";
				if ($flattr['setanc'] == '1' && $flattr['anc'] != '') {
					$output .= 	 $flattr['anc'] . "-";
				}
				$output 	.=	 $i . "\"></a>\n"
								."<script type=\"text/javascript\">\n"
								."var flattr_hide = 'true';\n"
								."var flattr_url = '" . $flattr['url'] . "#";
				if ($flattr['anc'] != '')
					$output .=	 $flattr['anc'] . "-";
				$output 	.=	 $i . "';\n"
								."</script>\n"
								."<script src=\"http://api.flattr.com/button/load.js\" type=\"text/javascript\"></script>\n";
				$i--;
			}
			if ($flattr['btn'] != '') {
				if ((!get_option('flattr_compact') || !class_exists('Flattr')) && $flattr['btn'] == 'compact') {
					$output .=	 "<script type=\"text/javascript\">"
								."var flattr_btn = 'large';\n"
								."</script>\n";
				}
			}
		}
		else {
			$output			=	 "<a href=\"" . $flattr['rssurl'] . "\" target=\"_blank\">\n"
								."<img src=\"";
			if ($flattr['btn'] == 'compact')
				$output		.=	 "http://api.flattr.com/button/button-compact-static-100x17.png";
			else
				$output		.=	 "http://api.flattr.com/button/button-static-50x60.png";
			$output			.=	 "\" alt=\"Flattr this\" title=\"Flattr this\" border=\"0\" /></a>";
				
		}

		return $output;
	}
	else
		return "<b>Flattr Widget Failed: A required variable was missing</b>";
}

function add_flattr_uid_box() {
	$flattr_author_uid	=	get_option('flattr_author_uid');
	if ($flattr_author_uid == 'true') {
		global $user_ID;
		if (preg_match('&profile.php&', $_SERVER['REQUEST_URI'])) {
			$id = $user_ID;
		} elseif($_GET['user_id']) {
			$id = $_GET['user_id'];
		}
		
		$flattr_uid = get_user_meta($id, 'flattr_uid', true);
?>

<table class="form-table">
<tr>
	<th><label for="flattr_uid">Flattr User ID:</label></th>
	<td><input type="text" name="flattr_uid" id="flattr_uid" value="<?php @print $flattr_uid ?>" class="regular-text" /></td>
</tr>
</table>

<?php
	}
}

function save_flattr_uid() {
	$flattr_author_uid	=	get_option('flattr_author_uid');
	if ($flattr_author_uid == 'true') {
		global $user_ID;
		if (preg_match('&profile.php&', $_SERVER['REQUEST_URI'])) {
			$id = $user_ID;
		} elseif($_GET['user_id']) {
			$id = $_GET['user_id'];
		}
		
		$flattr_uid = $_POST['flattr_uid'];
		
		update_usermeta($id, 'flattr_uid', $flattr_uid);
	}
}

function flattr_adminmenu() {
	add_options_page('Flatter Shortcode Widget', 'Flatter Shortcode Widget', 8, basename(__FILE__), 'flattr_options');
}

function flattr_options() {
	if (isset($_POST['flattr_options'])) {
		update_option('flattr_uid', $_POST['flattr_uid']);
		$flattr_author_uid = $_POST['flattr_author_uid'];
		if ($flattr_author_uid != 'true')
			$flattr_author_uid = 'false';
		update_option('flattr_author_uid', $flattr_author_uid);
		
		echo '<div id="message" class="updated fade"><p>Options Saved!</p></div>';
	}

	$flattr_uid = get_option('flattr_uid');
	$flattr_author_uid = get_option('flattr_author_uid');
	
	if (!isset($flattr_author_uid))
		$flattr_author_uid = 'true';

	?>
    
<div class="wrap">
 	<form id="flattr_options_form" method="post" action="">
		<h2>Flattr Shortcode Widget Options</h2> 
		
		<div id="poststuff" class="ui-sortable">
	
		<div class="postbox">
			<h3 class="hndle"><span>Default Widget Options</span></h3>
			<div class="inside">
       			<div><label for="flattr_uid">Default Flattr ID:</label>
       				<input type="text" size="40" id="flattr_uid" name="flattr_uid" value="<?php echo $flattr_uid ?>" /></div>
       		</div>
			
       	</div>
		
		<div class="postbox">
			<h3 class="hndle"><span>Blog Options</span></h3>
			<div class="inside">	
       			<div class="chkbox"><label for="flattr_author_uid">
       				<input type="checkbox" id="flattr_author_uid" name="flattr_author_uid" value="true"<?php if ($flattr_author_uid == 'true') echo ' checked="checked"' ?> />Allow authors to set their own default flattr that overrides the one above?</label>
       			</div>
			</div>
		</div>
	    <div class="submit"><input type="submit" name="flattr_options" id="flattr_options" value="Update Options" /></div>
	    </div>
	</form>
</div>
<?php	
}

//styling options page
function flattr_options_style() {
	?>
<style type="text/css" media="screen">
  	#flattr_options_form label { font-weight: bold; display: block; }
  	#flattr_options_form div { clear: both; margin-top: 5px; }	
  	
  	#flattr_options_form div.chkbox label { display: inline; }
  	#flattr_options_form .chkbox input { margin-right: 5px }
</style>
<?php
}

add_action('show_user_profile', 'add_flattr_uid_box');
add_action('edit_user_profile', 'add_flattr_uid_box');
add_action('profile_update', 'save_flattr_uid');

add_action('admin_menu', 'flattr_adminmenu');
add_action('admin_head', 'flattr_options_style');

add_shortcode('flattr', 'flattr_widget');
?>